//  W  Cɂ摜
//  9.`IASYɂ鏈
//  ext_face.c

unit GaMatch;

interface

uses
    Windows, SysUtils, Classes, SimpleGaCore, ImgHolder;

type
    //  ev[g}b`O
    TGenoTypeMatch = class(TGenoType)
    protected
        //  ev[g̒SW
        FPos: TPoint;

        //  g{
        FRate: Double;

        //  ]px
        FAngle: Double;

        //  ev[g̒SW()
        FPosR: TPoint;

        //  g{()
        FRateR: Double;

        //  ]px()
        FAngleR: Double;

        //  F̂p[^ɕϊ
        procedure CodeToParameter();

        //  p[^ۂ̒lɕϊ
        procedure RealizeParameter();

    public
        //  \
        function ToString(): String; override;

        //  Kx̌vZ
        function CalculateFitness(): Double; override;

        //  Rs[
        function Assign(const Source: TGenoType): TGenoType; override;

    public
        property Pos: TPoint read FPos;
        property Rate: Double read FRate;
        property Angle: Double read FAngle;
        property PosR: TPoint read FPosR;
        property RateR: Double read FRateR;
        property AngleR: Double read FAngleR;
    end;

const
    //  FNX̐F̃TCY
    //  ev[g摜̌摜ł̈ʒu(x,y) 8bit * 2
    //  g{ rate                           8bit
    //  ]px angle                          8bit
    GENE_SIZE_FOR_GAMATCH = 32;

const
    //  p[^
    PARAM_COUNT = 4;

    //  ЂƂ̃p[^̃TCY
    BIT_SIZE = 8;

    //  F̂p[^ɕϊƂ̃p[^̍ől
    //  TGenoTypeMatch.CodeToParameter() ŃR[h 11111111
    //  Ƃ̊ep[^̒l
    MAX_PARAM_SIZE = 255;

var
    //  ŏg{
    MIN_RATE: Double = 1.0;

    //  őg{
    MAX_RATE: Double = 2.0;

    //  ]px(-30[deg] - +30[deg])
    ANGLE_RANGE: Integer = 30;

    //  ŏ}b`O(}b`Ƃ݂ȂŒKx)
    MIN_MATCHING_RATE: Double = 0.99;
{
//    //  ~Ȃ͖
//    MIN_RANGE: Integer = 50;
}
const
    //  ő~l
    MAX_BRIGHTNESS = 255;

implementation

uses
    Math;

//=============================================================================
//  TGenoTypeMatch
//=============================================================================

//-----------------------------------------------------------------------------
//  F̂p[^ɕϊ
procedure TGenoTypeMatch.CodeToParameter();
var
    i: Integer;
begin
    //  OCR[hoCiR[hւ̕ϊ
    GrayToBinary(PARAM_COUNT, BIT_SIZE);

    //  p[^
    FillChar(FPos, SizeOf(FPos), 0);
    FRate := 0.0;
    FAngle := 0.0;

    //  ʒuϊ
    for i := 0 to BIT_SIZE - 1 do
    begin
        //  X W
        FPos.X := FPos.X * 2 + Binarysome[i + BIT_SIZE * 0];

        //  Y W
        FPos.Y := FPos.Y * 2 + Binarysome[i + BIT_SIZE * 1];

        //  g{
        FRate  := FRate  * 2 + Binarysome[i + BIT_SIZE * 2];

        //  ]px
        FAngle := FAngle * 2 + Binarysome[i + BIT_SIZE * 3];
    end;
end;

//-----------------------------------------------------------------------------
//  p[^ۂ̒lɕϊ
procedure TGenoTypeMatch.RealizeParameter();
begin
    //  X W
    FPosR.X := Trunc(FPos.X * GImageHolder.Image.Width  / MAX_PARAM_SIZE);

    //  Y W
    FPosR.Y := Trunc(FPos.Y * GImageHolder.Image.Height / MAX_PARAM_SIZE);

    //  g{
    FRateR := (MAX_RATE - MIN_RATE) * FRate / MAX_PARAM_SIZE + MIN_RATE;

    //  ]px
    FAngleR := ANGLE_RANGE * FAngle / MAX_PARAM_SIZE - ANGLE_RANGE / 2.0;
    if (FAngleR < 0) then FAngleR := FAngleR + 360.0;
end;

//-----------------------------------------------------------------------------
//  \
function TGenoTypeMatch.ToString(): String;
begin
    //  p[^o
    Result := Format('[XY]:%3d,%3d; [RT]:%3.2f; [AG]:%3.2f;',
                     [FPos.X, FPos.Y, FRate, FAngle])
            + Format('[XYR]:%3d,%3d; [RTR]:%3.2f; [AGR]:%3.2f; [FT]:%3.2f;',
                     [FPosR.X, FPosR.Y, FRateR, FAngleR, Fitness]);
end;

//-----------------------------------------------------------------------------
//  Kx̌vZ
function TGenoTypeMatch.CalculateFitness(): Double;
begin
    //  F̂p[^ɕϊ
    CodeToParameter();

    //  p[^ۂ̒lɕϊ
    RealizeParameter();

    //  ]Ă炤
    Fitness := GImageHolder.Eval(0, FPosR.X, FPosR.Y, FAngleR, FRateR);

    //  ߂
    Result := Fitness;
end;

//-----------------------------------------------------------------------------
//  Rs[
function TGenoTypeMatch.Assign(const Source: TGenoType): TGenoType;
var
    S: TGenoTypeMatch;
begin
    inherited Assign(Source);

    //  ̃NX̃CX^XRs[Xi
    S := TGenoTypeMatch(Source);

    //  ̔hNXŒǉoRs[
    FPos := S.FPos;
    FRate := S.FRate;
    FAngle := S.FAngle;
    FPosR := S.FPosR;
    FRateR := S.FRateR;
    FAngleR := S.FAngleR;

    //  g߂
    Result := Self;
end;

end.
