//  W  Cɂ摜
//  9.`IASYɂ鏈
//  myGA.h

//  2006.04.11 BlueLeaf1336 |
//  2006.04.29 C

unit SimpleGaCore;

interface

uses
    Windows, SysUtils, Classes, mt19937ar;

const
    //  Cardinal ̔
    HALF_CARDINAL = 4294967295 div 2;

    //  2l
    BOOL_TO_BYTE: array[Boolean] of Byte = (0, 1);

    //  ő̐
    MAX_POP_SIZE = 200;

    //  őF̒
    MAX_CHROMOSOME_SIZE = 50;

type
    //  F
    TChromosome = array[0..MAX_CHROMOSOME_SIZE-1] of Byte;

    //  `qNX
    TGenoType = class 
    protected
        //  F(OCR[h)
        Chromosome: TChromosome;

        //  F̃TCY
        function GetChromoSize(): Integer;
        property ChromoSize: Integer read GetChromoSize;

    public
        //  Kx
        Fitness: Double;

    protected
        //  F(oCiR[h)
        Binarysome: TChromosome;

        //  OCR[hoCiR[hւ̕ϊ
        procedure GrayToBinary(const ParamCount, BitSize: Integer);

    public
        //  RXgN^
        constructor Create();

        //  fXgN^
        destructor Destroy(); override;

        //  Rs[
        function Assign(const Source: TGenoType): TGenoType; virtual;

        //  \
        function ToString(): String; virtual;

        //  2̂̐F̂1_ĂƂɏ㏑
        procedure OnePointCrossOver(const Pair: TGenoType);

        //  2̂̐F̂2_ĂƂɏ㏑
        procedure TwoPointCrossOver(const Pair: TGenoType);

        //  2̂̐F̂lĂƂɏ㏑
        procedure UniFormCrossOver(const Pair: TGenoType);

        //  ˑRψ
        procedure Mutation(const MutationRate: Double);

        //  Kx̌vZ
        function CalculateFitness(): Double; virtual; abstract;
    end;

    //  `qNX^
    TGenoTypeClass = class of TGenoType;

    //  ̎
    TCrossOverType = (coOnePoint, coTwoPoint, coUniform);

    //  F̂
    TPopulation = class
    protected
        //  ̃Xg
        FGenes: TList;

        //  V̃Xg
        FGenesWork: TList;

        //  ŗǌ
        FBestGenoType: TGenoType;

        //  `qNX
        FGenoTypeClass: TGenoTypeClass;

    public
        //  RXgN^
        constructor Create(AGenoTypeClass: TGenoTypeClass);

        //  fXgN^
        destructor Destroy(); override;

        //  NA
        procedure Clear();

        //  F̏(̐ 100 - 1000)
        procedure InitializeGenes(const PopSize, ChromoSize: Integer);

        //  [bgIŎ̌̂߂
        procedure SelectionUsingRouletteRule();

        //  2̂_ɑgݍ킹Č(70% - 90%)
        procedure ExecuteCrossOver(const CrossType: TCrossOverType; const CrossRate: Double);

        //  S̂̓ˑRψ(0.1% - 5%)
        procedure ExecuteMutation(const MutationRate: Double);

        //  ŗǌ̂o
        function FindBestIndividual(): TGenoType;

        //  ň̂o
        function FindWorstIndividual(): TGenoType;

        //  G[g헪
        procedure ElitistStrategy();

        //  Kx̌vZ
        procedure CalculateFitness();

        //  i߂ȎOvZ
        procedure NextGenerationPrepare();

        //  1i߂
        procedure NextGeneration(const CrossType: TCrossOverType;
                                 const DoEliteStrategy: Boolean;
                                 const CrossRate: Double = 0.8;
                                 const MutationRate: Double = 0.01
                                 );

        //  \
        procedure ToStrings(Stream: TStream);

        //  o
        function Get(const Index: Integer): TGenoType;

        //  ̐
        function PopSize(): Integer;

    public
        property BestGenoType: TGenoType read FBestGenoType;
    end;

var
    GPopulation: TPopulation = nil;

implementation

var
    //  ̐
    GPopSize: Integer = MAX_POP_SIZE;

    //  F̒
    GChromoSize: Integer = MAX_CHROMOSOME_SIZE;

//=============================================================================
//  UTILITY
//=============================================================================

//-----------------------------------------------------------------------------
//  [0,N) ̐
function RandomInt(const n: Cardinal): Cardinal;
begin
    Result := GenRandInt32() mod n;
end;

//-----------------------------------------------------------------------------
//  ւ
procedure SwapInt(var a, b: Integer);
var
    n: Integer;
begin
    n := a;
    a := b;
    b := n;
end;

//=============================================================================
//  O[oϐ
//=============================================================================

//-----------------------------------------------------------------------------
//  ̐ݒ
function SetPopSize(const PopSize: Integer): Integer;
begin
    if (0 <= PopSize) and (PopSize <= MAX_POP_SIZE) then
    begin
        GPopSize := PopSize;
    end;
    Result := GPopSize;
end;

//-----------------------------------------------------------------------------
//  F̒ݒ
function SetChromoSize(const ChromoSize: Integer): Integer;
begin
    if (0 <= ChromoSize) and (ChromoSize <= MAX_CHROMOSOME_SIZE) then
    begin
        GChromoSize := ChromoSize;
    end;
    Result := GChromoSize;
end;

//=============================================================================
//  TGenoType
//=============================================================================

//-----------------------------------------------------------------------------
//  F̃TCY
function TGenoType.GetChromoSize(): Integer;
begin
    //  jbgϐ߂
    Result := GChromoSize;
end;

//-----------------------------------------------------------------------------
//  OCR[hoCiR[hւ̕ϊ
//      ParamCount  p[^̐                  ) 4
//      BitSize     ЂƂ̃p[^̃rbg    ) 8rbg
procedure TGenoType.GrayToBinary(const ParamCount, BitSize: Integer);
var
    i, j: Integer;
begin
    //  OCR[hRs[
    Move(Chromosome, Binarysome, SizeOf(Binarysome));

    //  Chromosome  0 / 1 ȂO
    for i := 0 to ParamCount - 1 do
    begin
        for j := 0 to BitSize - 2 do
        begin
            if (Binarysome[j + i * BitSize] = 1) then
            begin
                Binarysome[j + i * BitSize + 1] := 1 - Binarysome[j + i * BitSize + 1];    
            end;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  RXgN^
constructor TGenoType.Create();
var
    i: Integer;
begin
    inherited Create();

    //  ŐF̂
    for i := 0 to ChromoSize - 1 do
    begin
        Chromosome[i] := BOOL_TO_BYTE[GenRandInt32() <= HALF_CARDINAL];
    end;

    //  KxNA
    Fitness := 0;
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TGenoType.Destroy();
begin
    inherited;
end;

//-----------------------------------------------------------------------------
//  Rs[
function TGenoType.Assign(const Source: TGenoType): TGenoType;
begin
    //  F̂Rs[
    Move(Source.Chromosome, Chromosome, SizeOf(Chromosome));

    //  KxRs[
    Fitness := Source.Fitness;

    //  g߂
    Result := Self;
end;

//-----------------------------------------------------------------------------
//  \
function TGenoType.ToString(): String;
var
    i: Integer;
begin
    //  F(OCR[h)o
    Result := '[GC]:';
    for i := 0 to ChromoSize - 1 do
    begin
        Result := Result + IntToHex(Chromosome[i], 2);
        if ((i + 1) mod 8 = 0) then Result := Result + ' ';
    end;

    ////  Kxo
    //Result := Result + ' / ' + FormatFloat('0.00', Fitness);
end;

//-----------------------------------------------------------------------------
//  2̂̐F̂1_ĂƂɏ㏑
procedure TGenoType.OnePointCrossOver(const Pair: TGenoType);
var
    cp: Integer;
    i: Integer;
    n: Byte;
begin
    //  ʒu
    cp := RandomInt(ChromoSize);

    //  㔼ւ(擪͂Ȃ)
    for i := cp + 1 to ChromoSize - 1 do
    begin
        n := Chromosome[i];
        Chromosome[i] := Pair.Chromosome[i];
        Pair.Chromosome[i] := n;
    end;
end;

//-----------------------------------------------------------------------------
//  2̂̐F̂2_ĂƂɏ㏑
procedure TGenoType.TwoPointCrossOver(const Pair: TGenoType);
var
    cp1, cp2: Integer;
    i: Integer;
    n: Byte;
begin
    //  ڂ̌ʒu
    cp1 := RandomInt(ChromoSize);

    //  ڂ̌ʒu(ڂƈقȂ悤ɂ΂)
    repeat
        cp2 := RandomInt(ChromoSize);
    until
        (cp1 <> cp2);

    //  召𐮗
    if (cp2 < cp1) then SwapInt(cp1, cp2);

    //  ԕւ
    for i := cp1 + 1 to cp2 - 1 do
    begin
        n := Chromosome[i];
        Chromosome[i] := Pair.Chromosome[i];
        Pair.Chromosome[i] := n;
    end;
end;

//-----------------------------------------------------------------------------
//  2̂̐F̂lĂƂɏ㏑
//  2̂̐F̂𓙊mœւ
procedure TGenoType.UniFormCrossOver(const Pair: TGenoType);
var
    i: Integer;
    n: Byte;
begin
    for i := 0 to ChromoSize - 1 do
    begin
        if (GenRandInt32() <= HALF_CARDINAL) then
        begin
            n := Chromosome[i];
            Chromosome[i] := Pair.Chromosome[i];
            Pair.Chromosome[i] := n;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  ˑRψ
procedure TGenoType.Mutation(const MutationRate: Double);
var
    i: Integer;
begin
    for i := 0 to ChromoSize - 1 do
    begin
        if (GenRandReal2() <= MutationRate) then
        begin
            Chromosome[i] := BOOL_TO_BYTE[Chromosome[i] = 0];
        end;
    end;
end;

//=============================================================================
//  TPopulation
//=============================================================================

//-----------------------------------------------------------------------------
//  RXgN^
constructor TPopulation.Create(AGenoTypeClass: TGenoTypeClass);
begin
    inherited Create();
    FGenoTypeClass := AGenoTypeClass;
    FGenes := TList.Create();
    FGenesWork := TList.Create();
    FBestGenoType := FGenoTypeClass.Create();
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TPopulation.Destroy();
begin
    FBestGenoType.Free();
    Clear();
    FGenes.Free();
    FGenesWork.Free();
    inherited;
end;

//-----------------------------------------------------------------------------
//  o
function TPopulation.Get(const Index: Integer): TGenoType;
begin
    //  ͈̓`FbNT{
    Result := TGenoType(FGenes.Items[Index]);
end;

//-----------------------------------------------------------------------------
//  ̐
function TPopulation.PopSize(): Integer;
begin
    //  jbgϐ߂
    Result := GPopSize;
end;

//-----------------------------------------------------------------------------
//  F̂NA
procedure TPopulation.Clear();
begin
    while (FGenes.Count > 0) do
    begin
        Get(0).Free();
        FGenes.Delete(0);
    end;
    FGenesWork.Clear();
end;

//-----------------------------------------------------------------------------
//  ̂
procedure TPopulation.InitializeGenes(const PopSize, ChromoSize: Integer);
var
    i: Integer;
begin
    Clear();
    SetPopSize(PopSize);
    SetChromoSize(ChromoSize);
    for i := 0 to GPopSize - 1 do
    begin
        FGenes.Add(FGenoTypeClass.Create());
    end;
end;

//-----------------------------------------------------------------------------
//  [bgIŎ̌̂߂
procedure TPopulation.SelectionUsingRouletteRule();
var
    i, j: Integer;
    Sum, RandDbl: Double;
    RouletteTable: array[0..MAX_POP_SIZE-1] of Double;
    Selected: TGenoType;
begin
    //  ƗpXgNA
    FGenesWork.Clear();         

    //  ƗpXgɑS(̃|C^)𕡐
    //  [bgI͍ƗpXgɍs
    for i := 0 to FGenes.Count - 1 do
    begin
        FGenesWork.Add(FGenes.Items[i]);
    end;

    //  ̃XgNA
    FGenes.Clear();

    //  Kx̍vvZ
    Sum := 0.0;
    for i := 0 to GPopSize - 1 do
    begin
        Sum := Sum + TGenoType(FGenesWork.Items[i]).Fitness;
    end;

    //  e`q^̓KxɉRoulette̕蓖
    for i := 0 to GPopSize - 1 do
    begin
        RouletteTable[i] := TGenoType(FGenesWork.Items[i]).Fitness / Sum;
    end;

    //  Roulette1ɓWJ
    Sum := 0.0;
    for i := 0 to GPopSize - 1 do
    begin
        Sum := Sum + RouletteTable[i];
        RouletteTable[i] := Sum;
    end;

    //  I𑀍(Roulette̐܂킷)
    for i := 0 to GPopSize - 1 do
    begin
        //  [0.0, 1.0)
        RandDbl := GenRandReal2();

        //  I
        for j := 0 to GPopSize - 1 do
        begin
            if (RouletteTable[j] > RandDbl) then Break;
        end;

        //  Iꂽ̂ƗpXgɒǉ
        Selected := TGenoType(FGenesWork.Items[j]);

        //  ߂đIꂽꍇ͂ꎩ̂ǉ
        if (FGenes.IndexOf(Selected) = -1) then
        begin
            FGenes.Add(Selected);
        end

        //  2ڈȍ~̏ꍇ͕ʂ̃CX^X쐬Ēǉ
        else
        begin
            FGenes.Add(FGenoTypeClass.Create().Assign(Selected));
        end;
    end;

    //  1̂IꂽꍇAxIȂ̂
    //  (̑ɕʂ̌̂쐬Ă)
    //  ̑IȂ̂j

    //  FGenes({ԗp)ɂ̂AFGenesWork(Ɨp)珜
    for i := FGenesWork.Count - 1 downto 0 do
    begin
        if (FGenes.IndexOf(FGenesWork.Items[i]) <> -1) then
        begin
            FGenesWork.Delete(i);
        end;
    end;

    //  ׂ̂Ĕj
    while (FGenesWork.Count > 0) do
    begin
        TGenoType(FGenesWork.Items[0]).Free();
        FGenesWork.Delete(0);
    end;
end;

//-----------------------------------------------------------------------------
//  2̂_ɑgݍ킹Č
procedure TPopulation.ExecuteCrossOver(const CrossType: TCrossOverType; const CrossRate: Double);
var
    i, j: Integer;
    num1, num2: Integer;
    NumOfPair: Integer;
    Number: array[0..MAX_POP_SIZE-1] of Integer;
begin
    //  
    for i := 0 to GPopSize - 1 do Number[i] := i;

    //  _ɕבւ(Õ[v͂񐔂𑝂₷߂̂)
    for i := 0 to 9 do
    begin
        for j := 0 to GPopSize - 1 do
        begin
            num1 := RandomInt(GPopSize);
            num2 := RandomInt(GPopSize);
            SwapInt(Number[num1], Number[num2]);
        end;
    end;

    //  ^񒆂߂
    NumOfPair := GPopSize div 2;

    //  e2̌
    for i := 0 to NumOfPair - 1 do
    begin
        num1 := Number[2 * i];
        num2 := Number[2 * i + 1];

        //  邩ǂ
        if (GenRandReal2() <= CrossRate) then
        begin
            case CrossType of

            //  1_
            coOnePoint: Get(num1).OnePointCrossOver(Get(num2));

            //  2_
            coTwoPoint: Get(num1).TwoPointCrossOver(Get(num2));

            //  l
            coUniform:  Get(num1).UniFormCrossOver(Get(num2));

            end;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  S̂̓ˑRψ
procedure TPopulation.ExecuteMutation(const MutationRate: Double);
var
    i: Integer;
begin
    for i := 0 to GPopSize - 1 do
    begin
        Get(i).Mutation(MutationRate);
    end;
end;

//-----------------------------------------------------------------------------
//  ŗǌ̂o
function TPopulation.FindBestIndividual(): TGenoType;
var
    i: Integer;
    GenoType: TGenoType;
begin
    Result := nil;
    for i := 0 to GPopSize - 1 do
    begin
        GenoType := Get(i);
        if (Result = nil) then
        begin
            Result := GenoType;
        end
        else if (Result.Fitness <= GenoType.Fitness) then
        begin
            Result := GenoType;
        end;
    end;

    //  ŗǌ̂͌̃XgɊ܂܂Ȃ
    if (Result <> nil) then FBestGenoType.Assign(Result);
end;

//-----------------------------------------------------------------------------
//  ň̂o
function TPopulation.FindWorstIndividual(): TGenoType;
var
    i: Integer;
    GenoType: TGenoType;
begin
    Result := nil;
    for i := 0 to GPopSize - 1 do
    begin
        GenoType := Get(i);
        if (Result = nil) then
        begin
            Result := GenoType;
        end
        else if (Result.Fitness >= GenoType.Fitness) then
        begin
            Result := GenoType;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  G[g헪
procedure TPopulation.ElitistStrategy();
var
    WorstGenoType: TGenoType;
begin
    //  ň̂̌o
    WorstGenoType := FindWorstIndividual();

    //  ŗǌ̂Ɠւ
    WorstGenoType.Assign(FBestGenoType);
end;

//-----------------------------------------------------------------------------
//  Kx̌vZ
procedure TPopulation.CalculateFitness();
var
    i: Integer;
begin
    for i := 0 to GPopSize - 1 do
    begin
        Get(i).CalculateFitness();
    end;
end;

//-----------------------------------------------------------------------------
//  i߂ȎOvZ
procedure TPopulation.NextGenerationPrepare();
begin
    //  KxvZ
    CalculateFitness();

    //  ŗǌ̌o
    FindBestIndividual();
end;

//-----------------------------------------------------------------------------
//  1i߂
procedure TPopulation.NextGeneration(const CrossType: TCrossOverType;
                                 const DoEliteStrategy: Boolean;
                                 const CrossRate: Double = 0.8;
                                 const MutationRate: Double = 0.01
                                 );
begin
    //  RouletteI
    SelectionUsingRouletteRule();

    //  F̂̌
    ExecuteCrossOver(CrossType, CrossRate);

    //  ˑRψ
    ExecuteMutation(MutationRate);

    //  Kx̌vZ
    CalculateFitness();

    //  Elite헪
    if (DoEliteStrategy) then ElitistStrategy();

    //  ŗǌ̌o
    FindBestIndividual();
end;

//-----------------------------------------------------------------------------
//  ̂𕶎\
procedure TPopulation.ToStrings(Stream: TStream);
var
    i: Integer;
    Line: String;
    GenoType: TGenoType;
begin
    for i := 0 to GPopSize - 1 do
    begin
        GenoType := Get(i);
        Line := Format('%4d>', [i]) + GenoType.ToString() + #13#10;
        Stream.Write(Line[1], Length(Line));
    end;
    GenoType := FBestGenoType;
    Line := 'BEST>' + GenoType.ToString() + #13#10;
    Stream.Write(Line[1], Length(Line));
end;

//-----------------------------------------------------------------------------
var
    Seeds: array[0..3] of Cardinal;
initialization
    Seeds[0] := GetTickCount();
    Seeds[1] := Trunc(Now());
    Seeds[2] := Seeds[0];
    Seeds[3] := Seeds[1];
    InitByArray(Seeds);
end.
