unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, ComCtrls, ExtDlgs;

type
  TForm1 = class(TForm)
    Image2: TImage;
    Image1: TImage;
    PaintBox1: TPaintBox;
    Label1: TLabel;
    Label8: TLabel;
    Label2: TLabel;
    LblFitness: TLabel;
    Button1: TButton;
    LblGeneration: TLabel;
    Button2: TButton;
    Label3: TLabel;
    EditPopSize: TEdit;
    Label4: TLabel;
    EditLoopSize: TEdit;
    Label5: TLabel;
    EditCrossRate: TEdit;
    Label6: TLabel;
    EditMutationRate: TEdit;
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure EditPopSizeExit(Sender: TObject);
    procedure EditCrossRateExit(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

uses
    ImgHolder, SimpleGaCore, GaMatch;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TForm1.FormCreate(Sender: TObject);
begin
    PaintBox1.ControlStyle := PaintBox1.ControlStyle + [csOpaque];

    //  `pyCg{bNX̃TCY낦
    PaintBox1.BoundsRect := Image1.BoundsRect;

    //  摜NXɃZbg
    GImageHolder.Image := Image1.Picture.Bitmap;

    //  ev[g摜NXɃZbg
    GImageHolder.ClearTemplate();
    GImageHolder.AddTemplate(Image2.Picture.Bitmap);
    GImageHolder.SmoothingTemplate();

    //  O[XP[ϊꂽ̂߂ēǂݍ
    Image1.Picture.Bitmap.Assign(GImageHolder.Image);

    //  O[XP[ϊꂽ̂߂ēǂݍ
    Image2.Picture.Bitmap.Assign(GImageHolder.Template[0]);

    //  `ASYNX
    GPopulation := TPopulation.Create(TGenoTypeMatch);
    GPopulation.InitializeGenes(50, GENE_SIZE_FOR_GAMATCH);
    GPopulation.NextGenerationPrepare();
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TForm1.FormDestroy(Sender: TObject);
begin
    GPopulation.Free();
end;

//-----------------------------------------------------------------------------
//  `(摜ƕ]摜̈ʒuƕ])
procedure TForm1.PaintBox1Paint(Sender: TObject);
var
    i: Integer;
    BestType: TGenoTypeMatch;
    GenoType: TGenoTypeMatch;
    BestFitness: Double;
begin
    //  摜`
    BitBlt(PaintBox1.Canvas.Handle, 0, 0, PaintBox1.Width, PaintBox1.Height,
            Image1.Picture.Bitmap.Canvas.Handle, 0, 0, SRCCOPY);

    //  Ƃт̂悩`qNXo
    BestType := TGenoTypeMatch(GPopulation.BestGenoType);
    BestFitness := BestType.Fitness;

    //  ̕]l\
    LblFitness.Caption := FormatFloat('0.00000', BestFitness);

    if (BestType.Fitness < 0.9999) then
    begin
        //  摜ɏd˂`ŕ]Ώۂ̗̈`
        GImageHolder.Rotater.SetPoint(Image2.ClientRect);
        GImageHolder.Rotater.SetCenterOfPts();
        for i := 0 to GPopulation.PopSize - 1 do
        begin
            GenoType := TGenoTypeMatch(GPopulation.Get(i));
            if (GenoType.Fitness >= 0.95) then
            begin
                PaintBox1.Canvas.Pen.Color := clRed;
            end
            else if (GenoType.Fitness >= 0.85) then
            begin
                PaintBox1.Canvas.Pen.Color := clGreen;
            end
            else if (GenoType.Fitness >= 0.75) then
            begin
                PaintBox1.Canvas.Pen.Color := clYellow;
            end
            else
            begin
                //PaintBox1.Canvas.Pen.Color := clGray;
                Continue;
            end;

            GImageHolder.Rotater.TranslateX := GenoType.PosR.X;
            GImageHolder.Rotater.TranslateY := GenoType.PosR.Y;
            GImageHolder.Rotater.Radian := GenoType.AngleR;
            GImageHolder.Rotater.Rate   := GenoType.RateR;
            GImageHolder.Rotater.Execute();
            GImageHolder.Rotater.DrawResult(PaintBox1.Canvas, False);
        end;

    end;

    //  _ōō_z_[`
    PaintBox1.Canvas.Pen.Width := 2;
    PaintBox1.Canvas.Pen.Color := clBlue;
    GImageHolder.Rotater.TranslateX := BestType.PosR.X;
    GImageHolder.Rotater.TranslateY := BestType.PosR.Y;
    GImageHolder.Rotater.Radian := BestType.AngleR;
    GImageHolder.Rotater.Rate   := BestType.RateR;
    GImageHolder.Rotater.Execute();
    GImageHolder.Rotater.DrawResult(PaintBox1.Canvas, False);
    PaintBox1.Canvas.Pen.Width := 1;

    PaintBox1.Canvas.Pen.Color := clBlack;
end;

//-----------------------------------------------------------------------------
//  
procedure TForm1.Button1Click(Sender: TObject);
var
    i: Integer;
    GenoType: TGenoTypeMatch;
begin
    Button1.Enabled := False;
    Button2.Enabled := False;

    LblGeneration.Caption := 'Please Wait...';
    LblGeneration.Refresh();
    i := 0;
    while (i < EditLoopSize.Tag) do
    begin
        GPopulation.NextGeneration(coUniform, True, EditCrossRate.Tag / 100, EditMutationRate.Tag / 100);
        GenoType := TGenoTypeMatch(GPopulation.BestGenoType);
        if (GenoType.Fitness >= MIN_MATCHING_RATE) then Break;
        Inc(i);

        LblGeneration.Tag := LblGeneration.Tag + 1;
        LblGeneration.Caption := Format('generation%3.3d', [LblGeneration.Tag]);
        LblGeneration.Refresh();
        LblFitness.Caption := FormatFloat('0.0000', GenoType.Fitness);
        LblFitness.Refresh();
        PaintBox1.Repaint();
        Application.ProcessMessages();
    end;
    LblGeneration.Caption := Format('generation%3.3d', [LblGeneration.Tag]);
    PaintBox1.Repaint();

    Button1.Enabled := True;
    Button2.Enabled := True;
end;

//-----------------------------------------------------------------------------
//  蒼
procedure TForm1.Button2Click(Sender: TObject);
begin
    //  `ASYNX蒼
    GPopulation.Free();
    GPopulation := TPopulation.Create(TGenoTypeMatch);
    GPopulation.InitializeGenes(EditPopSize.Tag, GENE_SIZE_FOR_GAMATCH);
    GPopulation.NextGenerationPrepare();
    LblGeneration.Tag := 0;
    PaintBox1.Repaint();
end;

//-----------------------------------------------------------------------------
//  ̐EP̐㐔
procedure TForm1.EditPopSizeExit(Sender: TObject);
var
    LEdit: TEdit;
begin
    LEdit := TEdit(Sender);
    LEdit.Tag := StrToIntDef(LEdit.Text, LEdit.HelpContext);
    if (LEdit.Tag <= 0) then LEdit.Tag := LEdit.HelpContext;
end;

//-----------------------------------------------------------------------------
//  EˑRψٗ
procedure TForm1.EditCrossRateExit(Sender: TObject);
var
    LEdit: TEdit;
begin
    LEdit := TEdit(Sender);
    LEdit.Tag := Trunc(StrToFloatDef(LEdit.Text, LEdit.HelpContext));
    if (LEdit.Tag <= 0) then LEdit.Tag := LEdit.HelpContext;
    if (LEdit.Tag >= 1000) then LEdit.Tag := LEdit.HelpContext;
end;

end.
